#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <float.h>

int main() {
    double height, n, theta, min = DBL_MAX, max = 0.0;

    /* read in the height and number of samples */
    scanf("%lf\n%lf\n", &height, &n);

    /* loop through each sample */
    for (int i = 0; i < n; i++) {
        /* read this angle */
        scanf("%lf\n", &theta);
        
        /* do the calculation */
        double length = height * tan((theta * M_PI) / 180.0);

        /* check if this is a not min/max */
        if (length < min) {
            min = length;
        }
        if (length > max) {
            max = length;
        }
    }

    /* print the results */
    printf("The Shadowlands are between %d and %d meters.\n", (int) round(min),
            (int) round(max));

    return 0;
}

